%% Filepaths
folderFile = mfilename('fullpath');
file = mfilename();
folder = folderFile(1:end-length(file));
addpath(genpath(folder))

close all
%% Available data sets
input = load('input.mat');
input = input.input;
voltages = [1.1 0.9 0.7 0.5];
voltNames = ["V1_1" "V0_9" "V0_7" "V0_5"];

Cvec = [];
qvec = [];
% Choose data set index:  
for volt = 1:4

%% Load Data
yData = input.(voltNames(volt)).yData;
uData = input.(voltNames(volt)).uData; 
t_endCycle = 200;  % Unit min


[C q] = getCq(yData,t_endCycle,voltages(volt));
Cvec = [C Cvec];
qvec = [q qvec];
end

y = Cvec';
x = [ones(size(y,1),1) qvec.^2'];

Cavg = mean(Cvec);
k = x\y

figure
scatter(0.5:0.2:1.1,qvec,80,'filled','blue')
hold on;
vRange = linspace(0,1.2)';
plot(vRange,Cavg*vRange,'--black','LineWidth',2);
plot(vRange,qSolve(k(1),k(2),vRange),'b','LineWidth',2)
%xRange = [ones(size(vRange,1)
%plot(
axis([0 1.2 0 500])
xlabel('Voltage (V)')
ylabel('Charge (C)')
legend('Experiment','Model','Model+Correction')

figure
scatter(0.5:0.2:1.1,Cvec,80,'filled','red')
hold on;
plot(vRange,Cavg*ones(size(vRange,1),1),'--black','LineWidth',2)
plot(vRange,k(1)+k(2)*(qSolve(k(1),k(2),vRange)).^2,'r','LineWidth',2)
axis([0 1.2 0 400])
xlabel('Voltage (V)')
ylabel('Capacitance (F)')
legend('Experiment','Model','Model+Correction')

function [C,q] = getCq(data,t_end,V)
        yCycle = data(1:t_end);
        [~,t_switch] = max(yCycle);

        % C = q_sat/V
        q = (yCycle(t_switch)-yCycle(t_end));
        C = q/V;
end

function qRes = qSolve(C0,alpha,vRange)    
    f = @(q) q - (C0+alpha.*q.^2).*vRange;
    q0 = 350.*vRange;%zeros(size(vRange,1),1);
    qRes = fsolve(f,q0);
end