close all
data = csvread('LiteratureData.csv',2,0);
volt = [1.1 0.9 0.7 0.5];
yFull = [];
uFull = [];
for i = 1:4
    ind = 2*i-1;
    dat = data(:,ind:(ind+1));
    dat = dat(dat(:,1) ~= 0,:);
    dat = sortrows(dat);
    y = dat(:,2)*volt(i);
    y = y-y(1);
    tShift = dat(1,1);
    t = dat(:,1)- tShift;
    
    x = 0:max(round(t));
    dat = interp1(t,y,x,'makima','extrap')';
    yData = dat;
    
    tSwitch = sortrows(data(:,ind+8));
    tSwitch = tSwitch(tSwitch ~= 0);
    tSwitch = round(tSwitch - tShift);
    uData = zeros(length(yData),1);

    for time = 1:floor(length(tSwitch)/2)
        uData(max(tSwitch(2*time-1),1):...
              min(tSwitch(2*time),length(yData))) = volt(i);
    end
    
    %figure
    %plot(yData)
    %hold on
    %plot(uData*mean(yData))
    name = strrep(strcat("V",string(volt(i))),".","_");
    input.(name).yData = yData;
    input.(name).uData = uData;
    
    if i>1
        yFull = [yFull;yData+yFull(end)];
        uFull = [uFull;uData+uFull(end)];
    else
        yFull = yData;
        uFull = uData;
    end
end
input.full.yData = yFull;
input.full.uData = uFull;
save('input.mat','input')